Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/Makefile	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -240,5 +240,4 @@
 	generic/src/lib/func.c \
 	generic/src/lib/memstr.c \
-	generic/src/lib/memfnc.c \
 	generic/src/lib/sort.c \
 	generic/src/lib/str.c \
Index: kernel/arch/abs32le/include/memstr.h
===================================================================
--- kernel/arch/abs32le/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ kernel/arch/abs32le/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2010 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup abs32le
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_abs32le_MEMSTR_H_
+#define KERN_abs32le_MEMSTR_H_
+
+#define memcpy(dst, src, cnt)   _memcpy((dst), (src), (cnt))
+#define memsetb(dst, cnt, val)  _memsetb((dst), (cnt), (val))
+#define memsetw(dst, cnt, val)  _memsetw((dst), (cnt), (val))
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/amd64/Makefile.inc
===================================================================
--- kernel/arch/amd64/Makefile.inc	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/amd64/Makefile.inc	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -33,22 +33,5 @@
 
 FPU_NO_CFLAGS = -mno-sse -mno-sse2
-
-#
-# FIXME:
-#
-# The -fno-optimize-sibling-calls should be removed as soon as a bug
-# in GCC concerning the "large" memory model and tail call optimization
-# is fixed.
-#
-# If GCC generates a code for tail call, instead of generating ..
-#
-#   jmp *fnc
-#
-# it generates an assembly code with an illegal immediate prefix:
-#
-#   jmp *$fnc
-#
-
-CMN1 = -m64 -mcmodel=large -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer -fno-optimize-sibling-calls
+CMN1 = -m64 -mcmodel=large -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer
 GCC_CFLAGS += $(CMN1)
 ICC_CFLAGS += $(CMN1)
Index: kernel/arch/amd64/_link.ld.in
===================================================================
--- kernel/arch/amd64/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/amd64/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -26,10 +26,10 @@
 	.mapped (PA2KA(BOOT_OFFSET)+SIZEOF(.unmapped)) : AT (SIZEOF(.unmapped)) {
 		ktext_start = .;
-		*(.text .text.*);
+		*(.text);
 		ktext_end = .;
 		
 		kdata_start = .;
-		*(.data);              /* initialized data */
-		*(.rodata .rodata.*);  /* string literals */
+		*(.data);       /* initialized data */
+		*(.rodata*);    /* string literals */
 		hardcoded_load_address = .;
 		QUAD(PA2KA(BOOT_OFFSET));
Index: kernel/arch/amd64/include/memstr.h
===================================================================
--- kernel/arch/amd64/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ kernel/arch/amd64/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2005 Sergey Bondari
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup amd64
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_amd64_MEMSTR_H_
+#define KERN_amd64_MEMSTR_H_
+
+#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
+
+extern void memsetw(void *, size_t, uint16_t);
+extern void memsetb(void *, size_t, uint8_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/amd64/src/asm.S
===================================================================
--- kernel/arch/amd64/src/asm.S	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/amd64/src/asm.S	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -37,4 +37,7 @@
 .global read_efer_flag
 .global set_efer_flag
+.global memsetb
+.global memsetw
+.global memcpy
 .global memcpy_from_uspace
 .global memcpy_to_uspace
@@ -43,4 +46,12 @@
 .global early_putchar
 
+/* Wrapper for generic memsetb */
+memsetb:
+	jmp _memsetb
+
+/* Wrapper for generic memsetw */
+memsetw:
+	jmp _memsetw
+
 #define MEMCPY_DST   %rdi
 #define MEMCPY_SRC   %rsi
@@ -63,4 +74,5 @@
  *
  */
+memcpy:
 memcpy_from_uspace:
 memcpy_to_uspace:
Index: kernel/arch/arm32/include/memstr.h
===================================================================
--- kernel/arch/arm32/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ kernel/arch/arm32/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2005 Sergey Bondari
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup arm32
+ * @{
+ */
+/** @file
+ *  @brief Memory manipulating functions declarations.
+ */
+
+#ifndef KERN_arm32_MEMSTR_H_
+#define KERN_arm32_MEMSTR_H_
+
+#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
+
+extern void memsetw(void *, size_t, uint16_t);
+extern void memsetb(void *, size_t, uint8_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/arm32/src/asm.S
===================================================================
--- kernel/arch/arm32/src/asm.S	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/arm32/src/asm.S	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -29,4 +29,7 @@
 .text
 
+.global memsetb
+.global memsetw
+.global memcpy
 .global memcpy_from_uspace
 .global memcpy_to_uspace
@@ -35,4 +38,11 @@
 .global early_putchar
 
+memsetb:
+	b _memsetb
+
+memsetw:
+	b _memsetw
+
+memcpy:
 memcpy_from_uspace:
 memcpy_to_uspace:
Index: kernel/arch/arm32/src/exception.c
===================================================================
--- kernel/arch/arm32/src/exception.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/arm32/src/exception.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -35,4 +35,5 @@
 
 #include <arch/exception.h>
+#include <arch/memstr.h>
 #include <arch/regutils.h>
 #include <arch/machine_func.h>
Index: kernel/arch/arm32/src/mach/integratorcp/integratorcp.c
===================================================================
--- kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -292,5 +292,5 @@
 		.y = 480,
 		.scan = 2560,
-		.visual = VISUAL_RGB_8_8_8_0,
+		.visual = VISUAL_BGR_0_8_8_8,
 	};
 	
Index: kernel/arch/ia32/_link.ld.in
===================================================================
--- kernel/arch/ia32/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/ia32/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -25,10 +25,10 @@
 	.mapped (PA2KA(BOOT_OFFSET)+SIZEOF(.unmapped)): AT (SIZEOF(.unmapped)) { 
 		ktext_start = .;
-		*(.text .text.*);
+		*(.text);
 		ktext_end = .;
 		
 		kdata_start = .;
 		*(.data);               /* initialized data */
-		*(.rodata .rodata.*);   /* string literals */
+		*(.rodata*);            /* string literals */
 		*(COMMON);              /* global variables */
 		hardcoded_load_address = .;
Index: kernel/arch/ia32/include/memstr.h
===================================================================
--- kernel/arch/ia32/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ kernel/arch/ia32/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2005 Sergey Bondari
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ia32
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_ia32_MEMSTR_H_
+#define KERN_ia32_MEMSTR_H_
+
+#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
+
+extern void memsetw(void *, size_t, uint16_t);
+extern void memsetb(void *, size_t, uint8_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/ia32/src/asm.S
===================================================================
--- kernel/arch/ia32/src/asm.S	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/ia32/src/asm.S	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -38,4 +38,7 @@
 .global paging_on
 .global enable_l_apic_in_msr
+.global memsetb
+.global memsetw
+.global memcpy
 .global memcpy_from_uspace
 .global memcpy_from_uspace_failover_address
@@ -44,4 +47,12 @@
 .global early_putchar
 
+/* Wrapper for generic memsetb */
+memsetb:
+	jmp _memsetb
+
+/* Wrapper for generic memsetw */
+memsetw:
+	jmp _memsetw
+
 #define MEMCPY_DST   4
 #define MEMCPY_SRC   8
@@ -63,4 +74,5 @@
  *
  */
+memcpy:
 memcpy_from_uspace:
 memcpy_to_uspace:
Index: kernel/arch/ia32/src/cpu/cpu.c
===================================================================
--- kernel/arch/ia32/src/cpu/cpu.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/ia32/src/cpu/cpu.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -92,4 +92,5 @@
 void cpu_arch_init(void)
 {
+	cpuid_extended_feature_info efi;
 	cpu_info_t info;
 	uint32_t help = 0;
@@ -103,4 +104,5 @@
 	
 	CPU->arch.fi.word = info.cpuid_edx;
+	efi.word = info.cpuid_ecx;
 	
 	if (CPU->arch.fi.bits.fxsr)
Index: kernel/arch/ia64/_link.ld.in
===================================================================
--- kernel/arch/ia64/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/ia64/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -16,5 +16,5 @@
 		ktext_start = .;
 		*(K_TEXT_START);
-		*(.text .text.*)
+		*(.text)
 		ktext_end = .;
 		
@@ -36,14 +36,15 @@
 		*(.bss)
 		*(COMMON);
-		
+
 		. = ALIGN(8);
-		symbol_table = .;
-		*(symtab.*);            /* Symbol table, must be LAST symbol!*/
-		
+                symbol_table = .;
+                *(symtab.*);            /* Symbol table, must be LAST symbol!*/
+
 		kdata_end = .;
 	}
-	
+
 	/DISCARD/ : {
 		*(*);
 	}
+
 }
Index: kernel/arch/ia64/include/memstr.h
===================================================================
--- kernel/arch/ia64/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ kernel/arch/ia64/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2005 Sergey Bondari
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ia64
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_ia64_MEMSTR_H_
+#define KERN_ia64_MEMSTR_H_
+
+#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
+
+extern void memsetw(void *, size_t, uint16_t);
+extern void memsetb(void *, size_t, uint8_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/ia64/src/asm.S
===================================================================
--- kernel/arch/ia64/src/asm.S	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/ia64/src/asm.S	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -30,4 +30,5 @@
 
 .text
+.global memcpy
 .global memcpy_from_uspace
 .global memcpy_to_uspace
@@ -38,6 +39,5 @@
  *
  * This memcpy() has been taken from the assembler output of
- * a plain C implementation of memcpy() modified to have the
- * failover part.
+ * the generic _memcpy() and modified to have the failover part.
  *
  * @param in0 Destination address.
@@ -46,4 +46,5 @@
  *
  */
+memcpy:
 memcpy_from_uspace:
 memcpy_to_uspace:
@@ -140,4 +141,12 @@
 	br.ret.sptk.many rp
 
+.global memsetb
+memsetb:
+	br _memsetb
+
+.global memsetw
+memsetw:
+	br _memsetw
+
 .global cpu_halt
 cpu_halt:
Index: kernel/arch/ia64/src/mm/tlb.c
===================================================================
--- kernel/arch/ia64/src/mm/tlb.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/ia64/src/mm/tlb.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -475,8 +475,12 @@
 void alternate_instruction_tlb_fault(uint64_t vector, istate_t *istate)
 {
+	region_register_t rr;
+	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa; /* faulting address */
+	rr.word = rr_read(VA2VRN(va));
+	rid = rr.map.rid;
 	
 	page_table_lock(AS, true);
@@ -645,8 +649,12 @@
 void data_dirty_bit_fault(uint64_t vector, istate_t *istate)
 {
+	region_register_t rr;
+	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa;  /* faulting address */
+	rr.word = rr_read(VA2VRN(va));
+	rid = rr.map.rid;
 	
 	page_table_lock(AS, true);
@@ -678,8 +686,12 @@
 void instruction_access_bit_fault(uint64_t vector, istate_t *istate)
 {
+	region_register_t rr;
+	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa;  /* faulting address */
+	rr.word = rr_read(VA2VRN(va));
+	rid = rr.map.rid;
 	
 	page_table_lock(AS, true);
@@ -711,8 +723,12 @@
 void data_access_bit_fault(uint64_t vector, istate_t *istate)
 {
+	region_register_t rr;
+	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa;  /* faulting address */
+	rr.word = rr_read(VA2VRN(va));
+	rid = rr.map.rid;
 	
 	page_table_lock(AS, true);
@@ -744,8 +760,12 @@
 void data_access_rights_fault(uint64_t vector, istate_t *istate)
 {
+	region_register_t rr;
+	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa;  /* faulting address */
+	rr.word = rr_read(VA2VRN(va));
+	rid = rr.map.rid;
 	
 	/*
@@ -772,8 +792,12 @@
 void page_not_present(uint64_t vector, istate_t *istate)
 {
+	region_register_t rr;
+	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa;  /* faulting address */
+	rr.word = rr_read(VA2VRN(va));
+	rid = rr.map.rid;
 	
 	page_table_lock(AS, true);
Index: kernel/arch/mips32/include/cp0.h
===================================================================
--- kernel/arch/mips32/include/cp0.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/mips32/include/cp0.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -70,5 +70,5 @@
   { \
       uint32_t retval; \
-      asm volatile ("mfc0 %0, $" #reg : "=r"(retval)); \
+      asm("mfc0 %0, $" #reg : "=r"(retval)); \
       return retval; \
   }
@@ -76,5 +76,5 @@
 #define GEN_WRITE_CP0(nm,reg) static inline void cp0_ ##nm##_write(uint32_t val) \
  { \
-    asm volatile ("mtc0 %0, $" #reg : : "r"(val) ); \
+    asm("mtc0 %0, $" #reg : : "r"(val) ); \
  }
 
Index: kernel/arch/mips32/include/memstr.h
===================================================================
--- kernel/arch/mips32/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ kernel/arch/mips32/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2005 Sergey Bondari
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup mips32
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_mips32_MEMSTR_H_
+#define KERN_mips32_MEMSTR_H_
+
+#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
+
+extern void memsetw(void *, size_t, uint16_t);
+extern void memsetb(void *, size_t, uint8_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/mips32/src/asm.S
===================================================================
--- kernel/arch/mips32/src/asm.S	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/mips32/src/asm.S	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -57,8 +57,20 @@
 	nop
 
+.global memsetb
+memsetb:
+	j _memsetb
+	nop
+
+.global memsetw
+memsetw:
+	j _memsetw
+	nop
+
+.global memcpy
 .global memcpy_from_uspace
 .global memcpy_to_uspace
 .global memcpy_from_uspace_failover_address
 .global memcpy_to_uspace_failover_address
+memcpy:
 memcpy_from_uspace:
 memcpy_to_uspace:
Index: kernel/arch/ppc32/_link.ld.in
===================================================================
--- kernel/arch/ppc32/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/ppc32/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -36,5 +36,6 @@
 		kdata_start = .;
 		*(K_DATA_START);
-		*(.rodata .rodata.*);
+		*(.rodata);
+		*(.rodata.*);
 		*(.data);       /* initialized data */
 		*(.sdata);
Index: kernel/arch/ppc32/include/memstr.h
===================================================================
--- kernel/arch/ppc32/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ kernel/arch/ppc32/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2005 Sergey Bondari
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ppc32
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_ppc32_MEMSTR_H_
+#define KERN_ppc32_MEMSTR_H_
+
+#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
+
+extern void memsetw(void *, size_t, uint16_t);
+extern void memsetb(void *, size_t, uint8_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/ppc32/src/asm.S
===================================================================
--- kernel/arch/ppc32/src/asm.S	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/ppc32/src/asm.S	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -35,4 +35,7 @@
 .global iret
 .global iret_syscall
+.global memsetb
+.global memsetw
+.global memcpy
 .global memcpy_from_uspace
 .global memcpy_to_uspace
@@ -205,4 +208,11 @@
 	rfi
 
+memsetb:
+	b _memsetb
+
+memsetw:
+	b _memsetw
+
+memcpy:
 memcpy_from_uspace:
 memcpy_to_uspace:
Index: kernel/arch/sparc64/_link.ld.in
===================================================================
--- kernel/arch/sparc64/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/sparc64/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -15,10 +15,11 @@
 		ktext_start = .;
 		*(K_TEXT_START)
-		*(.text .text.*);
+		*(.text);
 		ktext_end = .;
 		
 		kdata_start = .;
 		*(K_DATA_START)
-		*(.rodata .rodata.*);
+		*(.rodata);
+		*(.rodata.*);
 		*(.data);                   /* initialized data */
 		*(.sdata);
Index: kernel/arch/sparc64/include/memstr.h
===================================================================
--- kernel/arch/sparc64/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ kernel/arch/sparc64/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2005 Sergey Bondari
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup sparc64
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_sparc64_MEMSTR_H_
+#define KERN_sparc64_MEMSTR_H_
+
+#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
+
+extern void memsetw(void *, size_t, uint16_t);
+extern void memsetb(void *, size_t, uint8_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/sparc64/src/mm/sun4u/as.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4u/as.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/sparc64/src/mm/sun4u/as.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -43,4 +43,5 @@
 
 #include <arch/mm/tsb.h>
+#include <arch/memstr.h>
 #include <arch/asm.h>
 #include <mm/frame.h>
Index: kernel/arch/sparc64/src/mm/sun4v/as.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/as.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/sparc64/src/mm/sun4v/as.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -46,4 +46,5 @@
 
 #include <arch/mm/tsb.h>
+#include <arch/memstr.h>
 #include <arch/asm.h>
 #include <mm/frame.h>
Index: kernel/arch/sparc64/src/smp/sun4v/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -1,5 +1,5 @@
 /*
  * Copyright (c) 2006 Jakub Jermar
- * Copyright (c) 2009 Pavel Rimsky
+ * Copyright (c) 2009 Pavel Rimsky 
  * All rights reserved.
  *
@@ -439,5 +439,5 @@
 	if (waitq_sleep_timeout(&ap_completion_wq, 10000000, SYNCH_FLAGS_NONE) ==
 	    ESYNCH_TIMEOUT)
-		printf("%s: waiting for processor (cpuid = %" PRIu64 ") timed out\n",
+		printf("%s: waiting for processor (cpuid = %" PRIu32 ") timed out\n",
 		    __func__, cpuid);
 	
Index: kernel/arch/sparc64/src/sun4v/start.S
===================================================================
--- kernel/arch/sparc64/src/sun4v/start.S	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/sparc64/src/sun4v/start.S	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -296,5 +296,5 @@
 	 * Create the first stack frame.
 	 */
-	save %sp, -(STACK_WINDOW_SAVE_AREA_SIZE + STACK_ARG_SAVE_AREA_SIZE), %sp
+	save %sp, -(STACK_WINDWO_SAVE_AREA_SIZE + STACK_ARG_SAVE_AREA_SIZE), %sp
 	flushw
 	add %g0, -STACK_BIAS, %fp
